{$APPTYPE CONSOLE}

var inp, out: text;
    suffixindex: array[1..20000] of integer;
    longstr: string;
    shortstr: string;
    n, m, i, j, a, b, c: integer;
    found: boolean;


procedure exchange (apar, bpar: integer);
var tl: integer;
begin
     tl := suffixindex[apar];
     suffixindex[apar] := suffixindex[bpar];
     suffixindex[bpar] := tl;
end;

function suffixlen (apar: integer): integer;
begin
     suffixlen := m - suffixindex[apar] + 1;
end;

function comparesuffixes (apar, bpar: integer): shortint;
var il: integer;
begin
     il := 0;
     while (il+1 <= suffixlen(apar)) and (il+1 <= suffixlen(bpar)) and (il+1 <= 255) and
           (longstr[suffixindex[apar] + il] = longstr[suffixindex[bpar] + il]) do inc (il);
     if il + 1 = 256 then comparesuffixes := 0
     else
         if (il+1 > suffixlen(apar)) or (longstr[suffixindex[apar] + il] < longstr[suffixindex[bpar] + il]) then
         comparesuffixes := -1
         else comparesuffixes := 1;
end;

procedure normalizetree (apar, bpar: integer);
var gl: integer;
begin
     while (apar*2 <= bpar) or (apar*2+1 <= bpar) do
     begin
          gl := apar;
          if (apar*2 <= bpar) and (comparesuffixes(apar, apar*2) < 0) then gl := apar*2;
          if (apar*2+1 <= bpar) and (comparesuffixes(gl, apar*2+1) < 0) then gl := apar*2+1;
          if gl = apar then exit
          else
          begin
               exchange (apar, gl);
               apar := gl;
          end;
     end;
end;

function compshandln (var shrl: string; lnind: integer): boolean;
var il: integer;
begin
     if suffixlen(lnind) > length(shrl) then compshandln := false
     else
     begin
          compshandln := true;
          for il := 1 to length(shrl) do if shrl[il] <> longstr[suffixindex[lnind] + il - 1] then compshandln := false;
     end;

end;

begin
     assign (inp, 'input.txt');
     assign (out, 'output.txt');
     reset (inp); rewrite (out);
     Readln(inp, longstr);
     m := Length(longstr);
     readln (inp, n);
     for i := 1 to m do suffixindex[i] := i;
     for i := m downto 1 do normalizetree (i, m);
     for i := m downto 1 do
     begin
          exchange (1, i);
          normalizetree (1, i-1);
     end;

     for i := 1 to n do
     begin
          readln (inp, shortstr);
          found := shortstr = '';
          if not found then begin
            a := 1;
            b := m;
            c := (a + b) div 2;
            while (a <= b) and (not found) do
            begin
                 j := 1;
                 while (shortstr[j] = longstr[suffixindex[c]+j-1]) and (j <= length(shortstr)) and
                       (j <= suffixlen(c)) do inc(j);
                 if j = length(shortstr) + 1 then found := true
                 else
                     if (j = suffixlen(c) + 1) or (shortstr[j] > longstr[suffixindex[c]+j-1]) then
                         a := c + 1
                     else
                         b := c - 1;
              c := (a + b) div 2;
            end;
          end;
          { if compshandln (shortstr, a) or compshandln (shortstr, b) then found := true; }
          if found then write (out, 1, ' ') else write (out, 0, ' ');
     end;
     close (out);
end.
